Loading...
1#!/bin/sh
2# SPDX-License-Identifier: GPL-2.0-only
3
4# Copyright (C) 2006 Paul Mackerras, IBM Corporation <paulus@samba.org>
5
6# This script takes a kernel binary and optionally an initrd image
7# and/or a device-tree blob, and creates a bootable zImage for a
8# given platform.
9
10# Options:
11# -o zImage specify output file
12# -p platform specify platform (links in $platform.o)
13# -i initrd specify initrd file
14# -d devtree specify device-tree blob
15# -s tree.dts specify device-tree source file (needs dtc installed)
16# -e esm_blob specify ESM blob for secure images
17# -c cache $kernel.strip.gz (use if present & newer, else make)
18# -C prefix specify command prefix for cross-building tools
19# (strip, objcopy, ld)
20# -D dir specify directory containing data files used by script
21# (default ./arch/powerpc/boot)
22# -W dir specify working directory for temporary files (default .)
23# -z use gzip (legacy)
24# -Z zsuffix compression to use (gz, xz or none)
25
26# Stop execution if any command fails
27set -e
28
29# Allow for verbose output
30if [ "$V" = 1 ]; then
31 set -x
32 map="-Map wrapper.map"
33fi
34
35# defaults
36kernel=
37ofile=zImage
38platform=of
39initrd=
40dtb=
41dts=
42esm_blob=
43cacheit=
44binary=
45compression=.gz
46uboot_comp=gzip
47pie=
48format=
49
50# cross-compilation prefix
51CROSS=
52
53# mkimage wrapper script
54MKIMAGE=$srctree/scripts/mkuboot.sh
55
56# directory for object and other files used by this script
57object=arch/powerpc/boot
58objbin=$object
59dtc=scripts/dtc/dtc
60
61# directory for working files
62tmpdir=.
63
64usage() {
65 echo 'Usage: wrapper [-o output] [-p platform] [-i initrd]' >&2
66 echo ' [-d devtree] [-s tree.dts] [-e esm_blob]' >&2
67 echo ' [-c] [-C cross-prefix] [-D datadir] [-W workingdir]' >&2
68 echo ' [-Z (gz|xz|none)] [--no-compression] [vmlinux]' >&2
69 exit 1
70}
71
72run_cmd() {
73 if [ "$V" = 1 ]; then
74 $* 2>&1
75 else
76 local msg
77
78 set +e
79 msg=$($* 2>&1)
80
81 if [ $? -ne "0" ]; then
82 echo $msg
83 exit 1
84 fi
85 set -e
86 fi
87}
88
89while [ "$#" -gt 0 ]; do
90 case "$1" in
91 -o)
92 shift
93 [ "$#" -gt 0 ] || usage
94 ofile="$1"
95 ;;
96 -p)
97 shift
98 [ "$#" -gt 0 ] || usage
99 platform="$1"
100 ;;
101 -i)
102 shift
103 [ "$#" -gt 0 ] || usage
104 initrd="$1"
105 ;;
106 -d)
107 shift
108 [ "$#" -gt 0 ] || usage
109 dtb="$1"
110 ;;
111 -e)
112 shift
113 [ "$#" -gt 0 ] || usage
114 esm_blob="$1"
115 ;;
116 -s)
117 shift
118 [ "$#" -gt 0 ] || usage
119 dts="$1"
120 ;;
121 -c)
122 cacheit=y
123 ;;
124 -C)
125 shift
126 [ "$#" -gt 0 ] || usage
127 CROSS="$1"
128 ;;
129 -D)
130 shift
131 [ "$#" -gt 0 ] || usage
132 object="$1"
133 objbin="$1"
134 ;;
135 -W)
136 shift
137 [ "$#" -gt 0 ] || usage
138 tmpdir="$1"
139 ;;
140 -z)
141 compression=.gz
142 uboot_comp=gzip
143 ;;
144 -Z)
145 shift
146 [ "$#" -gt 0 ] || usage
147 [ "$1" != "gz" -o "$1" != "xz" -o "$1" != "lzma" -o "$1" != "lzo" -o "$1" != "none" ] || usage
148
149 compression=".$1"
150 uboot_comp=$1
151
152 if [ $compression = ".none" ]; then
153 compression=
154 uboot_comp=none
155 fi
156 if [ $uboot_comp = "gz" ]; then
157 uboot_comp=gzip
158 fi
159 ;;
160 --no-gzip)
161 # a "feature" of the the wrapper script is that it can be used outside
162 # the kernel tree. So keeping this around for backwards compatibility.
163 compression=
164 uboot_comp=none
165 ;;
166 -?)
167 usage
168 ;;
169 *)
170 [ -z "$kernel" ] || usage
171 kernel="$1"
172 ;;
173 esac
174 shift
175done
176
177
178if [ -n "$dts" ]; then
179 if [ ! -r "$dts" -a -r "$object/dts/$dts" ]; then
180 dts="$object/dts/$dts"
181 fi
182 if [ -z "$dtb" ]; then
183 dtb="$platform.dtb"
184 fi
185 $dtc -O dtb -o "$dtb" -b 0 "$dts"
186fi
187
188if [ -z "$kernel" ]; then
189 kernel=vmlinux
190fi
191
192LANG=C elfformat="`${CROSS}objdump -p "$kernel" | grep 'file format' | awk '{print $4}'`"
193case "$elfformat" in
194 elf64-powerpcle) format=elf64lppc ;;
195 elf64-powerpc) format=elf32ppc ;;
196 elf32-powerpc) format=elf32ppc ;;
197esac
198
199ld_version()
200{
201 # Poached from scripts/ld-version.sh, but we don't want to call that because
202 # this script (wrapper) is distributed separately from the kernel source.
203 # Extract linker version number from stdin and turn into single number.
204 awk '{
205 gsub(".*\\)", "");
206 gsub(".*version ", "");
207 gsub("-.*", "");
208 split($1,a, ".");
209 print a[1]*100000000 + a[2]*1000000 + a[3]*10000;
210 exit
211 }'
212}
213
214# Do not include PT_INTERP segment when linking pie. Non-pie linking
215# just ignores this option.
216LD_VERSION=$(${CROSS}ld --version | ld_version)
217LD_NO_DL_MIN_VERSION=$(echo 2.26 | ld_version)
218if [ "$LD_VERSION" -ge "$LD_NO_DL_MIN_VERSION" ] ; then
219 nodl="--no-dynamic-linker"
220fi
221
222platformo=$object/"$platform".o
223lds=$object/zImage.lds
224ext=strip
225objflags=-S
226tmp=$tmpdir/zImage.$$.o
227ksection=.kernel:vmlinux.strip
228isection=.kernel:initrd
229esection=.kernel:esm_blob
230link_address='0x400000'
231make_space=y
232
233
234if [ -n "$esm_blob" -a "$platform" != "pseries" ]; then
235 echo "ESM blob not support on non-pseries platforms" >&2
236 exit 1
237fi
238
239case "$platform" in
240of)
241 platformo="$object/of.o $object/epapr.o"
242 make_space=n
243 ;;
244pseries)
245 platformo="$object/pseries-head.o $object/of.o $object/epapr.o"
246 link_address='0x4000000'
247 if [ "$format" != "elf32ppc" ]; then
248 link_address=
249 pie=-pie
250 fi
251 make_space=n
252 ;;
253maple)
254 platformo="$object/of.o $object/epapr.o"
255 link_address='0x400000'
256 make_space=n
257 ;;
258pmac|chrp)
259 platformo="$object/of.o $object/epapr.o"
260 make_space=n
261 ;;
262coff)
263 platformo="$object/crt0.o $object/of.o $object/epapr.o"
264 lds=$object/zImage.coff.lds
265 link_address='0x500000'
266 make_space=n
267 pie=
268 ;;
269miboot|uboot*)
270 # miboot and U-boot want just the bare bits, not an ELF binary
271 ext=bin
272 objflags="-O binary"
273 tmp="$ofile"
274 ksection=image
275 isection=initrd
276 ;;
277cuboot*)
278 binary=y
279 compression=
280 case "$platform" in
281 *-mpc866ads|*-mpc885ads|*-adder875*|*-ep88xc)
282 platformo=$object/cuboot-8xx.o
283 ;;
284 *5200*|*-motionpro)
285 platformo=$object/cuboot-52xx.o
286 ;;
287 *-pq2fads|*-ep8248e|*-mpc8272*|*-storcenter)
288 platformo=$object/cuboot-pq2.o
289 ;;
290 *-mpc824*)
291 platformo=$object/cuboot-824x.o
292 ;;
293 *-mpc83*|*-asp834x*)
294 platformo=$object/cuboot-83xx.o
295 ;;
296 *-tqm8541|*-mpc8560*|*-tqm8560|*-tqm8555|*-ksi8560*)
297 platformo=$object/cuboot-85xx-cpm2.o
298 ;;
299 *-mpc85*|*-tqm85*|*-sbc85*)
300 platformo=$object/cuboot-85xx.o
301 ;;
302 *-amigaone)
303 link_address='0x800000'
304 ;;
305 esac
306 ;;
307ps3)
308 platformo="$object/ps3-head.o $object/ps3-hvcall.o $object/ps3.o"
309 lds=$object/zImage.ps3.lds
310 compression=
311 ext=bin
312 objflags="-O binary --set-section-flags=.bss=contents,alloc,load,data"
313 ksection=.kernel:vmlinux.bin
314 isection=.kernel:initrd
315 link_address=''
316 make_space=n
317 pie=
318 ;;
319ep88xc|ep405|ep8248e)
320 platformo="$object/fixed-head.o $object/$platform.o"
321 binary=y
322 ;;
323adder875-redboot)
324 platformo="$object/fixed-head.o $object/redboot-8xx.o"
325 binary=y
326 ;;
327simpleboot-*)
328 platformo="$object/fixed-head.o $object/simpleboot.o"
329 binary=y
330 ;;
331asp834x-redboot)
332 platformo="$object/fixed-head.o $object/redboot-83xx.o"
333 binary=y
334 ;;
335xpedite52*)
336 link_address='0x1400000'
337 platformo=$object/cuboot-85xx.o
338 ;;
339gamecube|wii)
340 link_address='0x600000'
341 platformo="$object/$platform-head.o $object/$platform.o"
342 ;;
343treeboot-currituck)
344 link_address='0x1000000'
345 ;;
346treeboot-akebono)
347 link_address='0x1000000'
348 ;;
349treeboot-iss4xx-mpic)
350 platformo="$object/treeboot-iss4xx.o"
351 ;;
352epapr)
353 platformo="$object/pseries-head.o $object/epapr.o $object/epapr-wrapper.o"
354 link_address='0x20000000'
355 pie=-pie
356 ;;
357mvme5100)
358 platformo="$object/fixed-head.o $object/mvme5100.o"
359 binary=y
360 ;;
361mvme7100)
362 platformo="$object/motload-head.o $object/mvme7100.o"
363 link_address='0x4000000'
364 binary=y
365 ;;
366esac
367
368vmz="$tmpdir/`basename \"$kernel\"`.$ext"
369
370# Calculate the vmlinux.strip size
371${CROSS}objcopy $objflags "$kernel" "$vmz.$$"
372strip_size=$(${CONFIG_SHELL} "${srctree}/scripts/file-size.sh" "$vmz.$$")
373
374if [ -z "$cacheit" -o ! -f "$vmz$compression" -o "$vmz$compression" -ot "$kernel" ]; then
375 # recompress the image if we need to
376 case $compression in
377 .xz)
378 xz --check=crc32 -f -6 "$vmz.$$"
379 ;;
380 .gz)
381 gzip -n -f -9 "$vmz.$$"
382 ;;
383 .lzma)
384 xz --format=lzma -f -6 "$vmz.$$"
385 ;;
386 .lzo)
387 lzop -f -9 "$vmz.$$"
388 ;;
389 *)
390 # drop the compression suffix so the stripped vmlinux is used
391 compression=
392 uboot_comp=none
393 ;;
394 esac
395
396 if [ -n "$cacheit" ]; then
397 mv -f "$vmz.$$$compression" "$vmz$compression"
398 else
399 vmz="$vmz.$$"
400 fi
401else
402 rm -f $vmz.$$
403fi
404
405vmz="$vmz$compression"
406
407if [ "$make_space" = "y" ]; then
408 # Round the size to next higher MB limit
409 round_size=$(((strip_size + 0xfffff) & 0xfff00000))
410
411 round_size=0x$(printf "%x" $round_size)
412 link_addr=$(printf "%d" $link_address)
413
414 if [ $link_addr -lt $strip_size ]; then
415 echo "INFO: Uncompressed kernel (size 0x$(printf "%x\n" $strip_size))" \
416 "overlaps the address of the wrapper($link_address)"
417 echo "INFO: Fixing the link_address of wrapper to ($round_size)"
418 link_address=$round_size
419 fi
420fi
421
422# Extract kernel version information, some platforms want to include
423# it in the image header
424version=`${CROSS}strings "$kernel" | grep '^Linux version [-0-9.]' | \
425 cut -d' ' -f3`
426if [ -n "$version" ]; then
427 uboot_version="-n Linux-$version"
428fi
429
430# physical offset of kernel image
431membase=`${CROSS}objdump -p "$kernel" | grep -m 1 LOAD | awk '{print $7}'`
432
433case "$platform" in
434uboot)
435 rm -f "$ofile"
436 ${MKIMAGE} -A ppc -O linux -T kernel -C $uboot_comp -a $membase -e $membase \
437 $uboot_version -d "$vmz" "$ofile"
438 if [ -z "$cacheit" ]; then
439 rm -f "$vmz"
440 fi
441 exit 0
442 ;;
443uboot-obs600)
444 rm -f "$ofile"
445 # obs600 wants a multi image with an initrd, so we need to put a fake
446 # one in even when building a "normal" image.
447 if [ -n "$initrd" ]; then
448 real_rd="$initrd"
449 else
450 real_rd=`mktemp`
451 echo "\0" >>"$real_rd"
452 fi
453 ${MKIMAGE} -A ppc -O linux -T multi -C gzip -a $membase -e $membase \
454 $uboot_version -d "$vmz":"$real_rd":"$dtb" "$ofile"
455 if [ -z "$initrd" ]; then
456 rm -f "$real_rd"
457 fi
458 if [ -z "$cacheit" ]; then
459 rm -f "$vmz"
460 fi
461 exit 0
462 ;;
463esac
464
465addsec() {
466 ${CROSS}objcopy $4 $1 \
467 --add-section=$3="$2" \
468 --set-section-flags=$3=contents,alloc,load,readonly,data
469}
470
471addsec $tmp "$vmz" $ksection $object/empty.o
472if [ -z "$cacheit" ]; then
473 rm -f "$vmz"
474fi
475
476if [ -n "$initrd" ]; then
477 addsec $tmp "$initrd" $isection
478fi
479
480if [ -n "$dtb" ]; then
481 addsec $tmp "$dtb" .kernel:dtb
482 if [ -n "$dts" ]; then
483 rm $dtb
484 fi
485fi
486
487if [ -n "$esm_blob" ]; then
488 addsec $tmp "$esm_blob" $esection
489fi
490
491if [ "$platform" != "miboot" ]; then
492 if [ -n "$link_address" ] ; then
493 text_start="-Ttext $link_address"
494 fi
495#link everything
496 ${CROSS}ld -m $format -T $lds $text_start $pie $nodl -o "$ofile" $map \
497 $platformo $tmp $object/wrapper.a
498 rm $tmp
499fi
500
501# Some platforms need the zImage's entry point and base address
502base=0x`${CROSS}nm "$ofile" | grep ' _start$' | cut -d' ' -f1`
503entry=`${CROSS}objdump -f "$ofile" | grep '^start address ' | cut -d' ' -f3`
504
505if [ -n "$binary" ]; then
506 mv "$ofile" "$ofile".elf
507 ${CROSS}objcopy -O binary "$ofile".elf "$ofile"
508fi
509
510# post-processing needed for some platforms
511case "$platform" in
512pseries|chrp|maple)
513 $objbin/addnote "$ofile"
514 ;;
515coff)
516 ${CROSS}objcopy -O aixcoff-rs6000 --set-start "$entry" "$ofile"
517 $objbin/hack-coff "$ofile"
518 ;;
519cuboot*)
520 gzip -n -f -9 "$ofile"
521 ${MKIMAGE} -A ppc -O linux -T kernel -C gzip -a "$base" -e "$entry" \
522 $uboot_version -d "$ofile".gz "$ofile"
523 ;;
524treeboot*)
525 mv "$ofile" "$ofile.elf"
526 $objbin/mktree "$ofile.elf" "$ofile" "$base" "$entry"
527 if [ -z "$cacheit" ]; then
528 rm -f "$ofile.elf"
529 fi
530 exit 0
531 ;;
532ps3)
533 # The ps3's loader supports loading a gzipped binary image from flash
534 # rom to ram addr zero. The loader then enters the system reset
535 # vector at addr 0x100. A bootwrapper overlay is used to arrange for
536 # a binary image of the kernel to be at addr zero, and yet have a
537 # suitable bootwrapper entry at 0x100. To construct the final rom
538 # image 512 bytes from offset 0x100 is copied to the bootwrapper
539 # place holder at symbol __system_reset_kernel. The 512 bytes of the
540 # bootwrapper entry code at symbol __system_reset_overlay is then
541 # copied to offset 0x100. At runtime the bootwrapper program copies
542 # the data at __system_reset_kernel back to addr 0x100.
543
544 system_reset_overlay=0x`${CROSS}nm "$ofile" \
545 | grep ' __system_reset_overlay$' \
546 | cut -d' ' -f1`
547 system_reset_overlay=`printf "%d" $system_reset_overlay`
548 system_reset_kernel=0x`${CROSS}nm "$ofile" \
549 | grep ' __system_reset_kernel$' \
550 | cut -d' ' -f1`
551 system_reset_kernel=`printf "%d" $system_reset_kernel`
552 overlay_dest="256"
553 overlay_size="512"
554
555 ${CROSS}objcopy -O binary "$ofile" "$ofile.bin"
556
557 run_cmd dd if="$ofile.bin" of="$ofile.bin" conv=notrunc \
558 skip=$overlay_dest seek=$system_reset_kernel \
559 count=$overlay_size bs=1
560
561 run_cmd dd if="$ofile.bin" of="$ofile.bin" conv=notrunc \
562 skip=$system_reset_overlay seek=$overlay_dest \
563 count=$overlay_size bs=1
564
565 odir="$(dirname "$ofile.bin")"
566
567 # The ps3's flash loader has a size limit of 16 MiB for the uncompressed
568 # image. If a compressed image that exceeded this limit is written to
569 # flash the loader will decompress that image until the 16 MiB limit is
570 # reached, then enter the system reset vector of the partially decompressed
571 # image. No warning is issued.
572 rm -f "$odir"/{otheros,otheros-too-big}.bld
573 size=$(${CROSS}nm --no-sort --radix=d "$ofile" | egrep ' _end$' | cut -d' ' -f1)
574 bld="otheros.bld"
575 if [ $size -gt $((0x1000000)) ]; then
576 bld="otheros-too-big.bld"
577 fi
578 gzip -n --force -9 --stdout "$ofile.bin" > "$odir/$bld"
579 ;;
580esac
1#!/bin/sh
2
3# Copyright (C) 2006 Paul Mackerras, IBM Corporation <paulus@samba.org>
4# This program may be used under the terms of version 2 of the GNU
5# General Public License.
6
7# This script takes a kernel binary and optionally an initrd image
8# and/or a device-tree blob, and creates a bootable zImage for a
9# given platform.
10
11# Options:
12# -o zImage specify output file
13# -p platform specify platform (links in $platform.o)
14# -i initrd specify initrd file
15# -d devtree specify device-tree blob
16# -s tree.dts specify device-tree source file (needs dtc installed)
17# -c cache $kernel.strip.gz (use if present & newer, else make)
18# -C prefix specify command prefix for cross-building tools
19# (strip, objcopy, ld)
20# -D dir specify directory containing data files used by script
21# (default ./arch/powerpc/boot)
22# -W dir specify working directory for temporary files (default .)
23
24# Stop execution if any command fails
25set -e
26
27# Allow for verbose output
28if [ "$V" = 1 ]; then
29 set -x
30fi
31
32# defaults
33kernel=
34ofile=zImage
35platform=of
36initrd=
37dtb=
38dts=
39cacheit=
40binary=
41gzip=.gz
42pie=
43
44# cross-compilation prefix
45CROSS=
46
47# mkimage wrapper script
48MKIMAGE=$srctree/scripts/mkuboot.sh
49
50# directory for object and other files used by this script
51object=arch/powerpc/boot
52objbin=$object
53dtc=scripts/dtc/dtc
54
55# directory for working files
56tmpdir=.
57
58usage() {
59 echo 'Usage: wrapper [-o output] [-p platform] [-i initrd]' >&2
60 echo ' [-d devtree] [-s tree.dts] [-c] [-C cross-prefix]' >&2
61 echo ' [-D datadir] [-W workingdir] [--no-gzip] [vmlinux]' >&2
62 exit 1
63}
64
65while [ "$#" -gt 0 ]; do
66 case "$1" in
67 -o)
68 shift
69 [ "$#" -gt 0 ] || usage
70 ofile="$1"
71 ;;
72 -p)
73 shift
74 [ "$#" -gt 0 ] || usage
75 platform="$1"
76 ;;
77 -i)
78 shift
79 [ "$#" -gt 0 ] || usage
80 initrd="$1"
81 ;;
82 -d)
83 shift
84 [ "$#" -gt 0 ] || usage
85 dtb="$1"
86 ;;
87 -s)
88 shift
89 [ "$#" -gt 0 ] || usage
90 dts="$1"
91 ;;
92 -c)
93 cacheit=y
94 ;;
95 -C)
96 shift
97 [ "$#" -gt 0 ] || usage
98 CROSS="$1"
99 ;;
100 -D)
101 shift
102 [ "$#" -gt 0 ] || usage
103 object="$1"
104 objbin="$1"
105 ;;
106 -W)
107 shift
108 [ "$#" -gt 0 ] || usage
109 tmpdir="$1"
110 ;;
111 --no-gzip)
112 gzip=
113 ;;
114 -?)
115 usage
116 ;;
117 *)
118 [ -z "$kernel" ] || usage
119 kernel="$1"
120 ;;
121 esac
122 shift
123done
124
125if [ -n "$dts" ]; then
126 if [ ! -r "$dts" -a -r "$object/dts/$dts" ]; then
127 dts="$object/dts/$dts"
128 fi
129 if [ -z "$dtb" ]; then
130 dtb="$platform.dtb"
131 fi
132 $dtc -O dtb -o "$dtb" -b 0 "$dts"
133fi
134
135if [ -z "$kernel" ]; then
136 kernel=vmlinux
137fi
138
139platformo=$object/"$platform".o
140lds=$object/zImage.lds
141ext=strip
142objflags=-S
143tmp=$tmpdir/zImage.$$.o
144ksection=.kernel:vmlinux.strip
145isection=.kernel:initrd
146link_address='0x400000'
147make_space=y
148
149case "$platform" in
150of)
151 platformo="$object/of.o $object/epapr.o"
152 make_space=n
153 ;;
154pseries)
155 platformo="$object/of.o $object/epapr.o"
156 link_address='0x4000000'
157 make_space=n
158 ;;
159maple)
160 platformo="$object/of.o $object/epapr.o"
161 link_address='0x400000'
162 make_space=n
163 ;;
164pmac|chrp)
165 platformo="$object/of.o $object/epapr.o"
166 make_space=n
167 ;;
168coff)
169 platformo="$object/crt0.o $object/of.o $object/epapr.o"
170 lds=$object/zImage.coff.lds
171 link_address='0x500000'
172 make_space=n
173 pie=
174 ;;
175miboot|uboot*)
176 # miboot and U-boot want just the bare bits, not an ELF binary
177 ext=bin
178 objflags="-O binary"
179 tmp="$ofile"
180 ksection=image
181 isection=initrd
182 ;;
183cuboot*)
184 binary=y
185 gzip=
186 case "$platform" in
187 *-mpc866ads|*-mpc885ads|*-adder875*|*-ep88xc)
188 platformo=$object/cuboot-8xx.o
189 ;;
190 *5200*|*-motionpro)
191 platformo=$object/cuboot-52xx.o
192 ;;
193 *-pq2fads|*-ep8248e|*-mpc8272*|*-storcenter)
194 platformo=$object/cuboot-pq2.o
195 ;;
196 *-mpc824*)
197 platformo=$object/cuboot-824x.o
198 ;;
199 *-mpc83*|*-asp834x*)
200 platformo=$object/cuboot-83xx.o
201 ;;
202 *-tqm8541|*-mpc8560*|*-tqm8560|*-tqm8555|*-ksi8560*)
203 platformo=$object/cuboot-85xx-cpm2.o
204 ;;
205 *-mpc85*|*-tqm85*|*-sbc85*)
206 platformo=$object/cuboot-85xx.o
207 ;;
208 *-amigaone)
209 link_address='0x800000'
210 ;;
211 esac
212 ;;
213ps3)
214 platformo="$object/ps3-head.o $object/ps3-hvcall.o $object/ps3.o"
215 lds=$object/zImage.ps3.lds
216 gzip=
217 ext=bin
218 objflags="-O binary --set-section-flags=.bss=contents,alloc,load,data"
219 ksection=.kernel:vmlinux.bin
220 isection=.kernel:initrd
221 link_address=''
222 make_space=n
223 pie=
224 ;;
225ep88xc|ep405|ep8248e)
226 platformo="$object/fixed-head.o $object/$platform.o"
227 binary=y
228 ;;
229adder875-redboot)
230 platformo="$object/fixed-head.o $object/redboot-8xx.o"
231 binary=y
232 ;;
233simpleboot-virtex405-*)
234 platformo="$object/virtex405-head.o $object/simpleboot.o $object/virtex.o"
235 binary=y
236 ;;
237simpleboot-virtex440-*)
238 platformo="$object/fixed-head.o $object/simpleboot.o $object/virtex.o"
239 binary=y
240 ;;
241simpleboot-*)
242 platformo="$object/fixed-head.o $object/simpleboot.o"
243 binary=y
244 ;;
245asp834x-redboot)
246 platformo="$object/fixed-head.o $object/redboot-83xx.o"
247 binary=y
248 ;;
249xpedite52*)
250 link_address='0x1400000'
251 platformo=$object/cuboot-85xx.o
252 ;;
253gamecube|wii)
254 link_address='0x600000'
255 platformo="$object/$platform-head.o $object/$platform.o"
256 ;;
257treeboot-currituck)
258 link_address='0x1000000'
259 ;;
260treeboot-iss4xx-mpic)
261 platformo="$object/treeboot-iss4xx.o"
262 ;;
263epapr)
264 platformo="$object/epapr.o $object/epapr-wrapper.o"
265 link_address='0x20000000'
266 pie=-pie
267 ;;
268mvme5100)
269 platformo="$object/fixed-head.o $object/mvme5100.o"
270 binary=y
271 ;;
272esac
273
274vmz="$tmpdir/`basename \"$kernel\"`.$ext"
275if [ -z "$cacheit" -o ! -f "$vmz$gzip" -o "$vmz$gzip" -ot "$kernel" ]; then
276 ${CROSS}objcopy $objflags "$kernel" "$vmz.$$"
277
278 strip_size=$(stat -c %s $vmz.$$)
279
280 if [ -n "$gzip" ]; then
281 gzip -n -f -9 "$vmz.$$"
282 fi
283
284 if [ -n "$cacheit" ]; then
285 mv -f "$vmz.$$$gzip" "$vmz$gzip"
286 else
287 vmz="$vmz.$$"
288 fi
289else
290 # Calculate the vmlinux.strip size
291 ${CROSS}objcopy $objflags "$kernel" "$vmz.$$"
292 strip_size=$(stat -c %s $vmz.$$)
293 rm -f $vmz.$$
294fi
295
296if [ "$make_space" = "y" ]; then
297 # Round the size to next higher MB limit
298 round_size=$(((strip_size + 0xfffff) & 0xfff00000))
299
300 round_size=0x$(printf "%x" $round_size)
301 link_addr=$(printf "%d" $link_address)
302
303 if [ $link_addr -lt $strip_size ]; then
304 echo "INFO: Uncompressed kernel (size 0x$(printf "%x\n" $strip_size))" \
305 "overlaps the address of the wrapper($link_address)"
306 echo "INFO: Fixing the link_address of wrapper to ($round_size)"
307 link_address=$round_size
308 fi
309fi
310
311vmz="$vmz$gzip"
312
313# Extract kernel version information, some platforms want to include
314# it in the image header
315version=`${CROSS}strings "$kernel" | grep '^Linux version [-0-9.]' | \
316 cut -d' ' -f3`
317if [ -n "$version" ]; then
318 uboot_version="-n Linux-$version"
319fi
320
321# physical offset of kernel image
322membase=`${CROSS}objdump -p "$kernel" | grep -m 1 LOAD | awk '{print $7}'`
323
324case "$platform" in
325uboot)
326 rm -f "$ofile"
327 ${MKIMAGE} -A ppc -O linux -T kernel -C gzip -a $membase -e $membase \
328 $uboot_version -d "$vmz" "$ofile"
329 if [ -z "$cacheit" ]; then
330 rm -f "$vmz"
331 fi
332 exit 0
333 ;;
334uboot-obs600)
335 rm -f "$ofile"
336 # obs600 wants a multi image with an initrd, so we need to put a fake
337 # one in even when building a "normal" image.
338 if [ -n "$initrd" ]; then
339 real_rd="$initrd"
340 else
341 real_rd=`mktemp`
342 echo "\0" >>"$real_rd"
343 fi
344 ${MKIMAGE} -A ppc -O linux -T multi -C gzip -a $membase -e $membase \
345 $uboot_version -d "$vmz":"$real_rd":"$dtb" "$ofile"
346 if [ -z "$initrd" ]; then
347 rm -f "$real_rd"
348 fi
349 if [ -z "$cacheit" ]; then
350 rm -f "$vmz"
351 fi
352 exit 0
353 ;;
354esac
355
356addsec() {
357 ${CROSS}objcopy $4 $1 \
358 --add-section=$3="$2" \
359 --set-section-flags=$3=contents,alloc,load,readonly,data
360}
361
362addsec $tmp "$vmz" $ksection $object/empty.o
363if [ -z "$cacheit" ]; then
364 rm -f "$vmz"
365fi
366
367if [ -n "$initrd" ]; then
368 addsec $tmp "$initrd" $isection
369fi
370
371if [ -n "$dtb" ]; then
372 addsec $tmp "$dtb" .kernel:dtb
373 if [ -n "$dts" ]; then
374 rm $dtb
375 fi
376fi
377
378if [ "$platform" != "miboot" ]; then
379 if [ -n "$link_address" ] ; then
380 text_start="-Ttext $link_address"
381 fi
382 ${CROSS}ld -m elf32ppc -T $lds $text_start $pie -o "$ofile" \
383 $platformo $tmp $object/wrapper.a
384 rm $tmp
385fi
386
387# Some platforms need the zImage's entry point and base address
388base=0x`${CROSS}nm "$ofile" | grep ' _start$' | cut -d' ' -f1`
389entry=`${CROSS}objdump -f "$ofile" | grep '^start address ' | cut -d' ' -f3`
390
391if [ -n "$binary" ]; then
392 mv "$ofile" "$ofile".elf
393 ${CROSS}objcopy -O binary "$ofile".elf "$ofile"
394fi
395
396# post-processing needed for some platforms
397case "$platform" in
398pseries|chrp|maple)
399 $objbin/addnote "$ofile"
400 ;;
401coff)
402 ${CROSS}objcopy -O aixcoff-rs6000 --set-start "$entry" "$ofile"
403 $objbin/hack-coff "$ofile"
404 ;;
405cuboot*)
406 gzip -n -f -9 "$ofile"
407 ${MKIMAGE} -A ppc -O linux -T kernel -C gzip -a "$base" -e "$entry" \
408 $uboot_version -d "$ofile".gz "$ofile"
409 ;;
410treeboot*)
411 mv "$ofile" "$ofile.elf"
412 $objbin/mktree "$ofile.elf" "$ofile" "$base" "$entry"
413 if [ -z "$cacheit" ]; then
414 rm -f "$ofile.elf"
415 fi
416 exit 0
417 ;;
418ps3)
419 # The ps3's loader supports loading a gzipped binary image from flash
420 # rom to ram addr zero. The loader then enters the system reset
421 # vector at addr 0x100. A bootwrapper overlay is used to arrange for
422 # a binary image of the kernel to be at addr zero, and yet have a
423 # suitable bootwrapper entry at 0x100. To construct the final rom
424 # image 512 bytes from offset 0x100 is copied to the bootwrapper
425 # place holder at symbol __system_reset_kernel. The 512 bytes of the
426 # bootwrapper entry code at symbol __system_reset_overlay is then
427 # copied to offset 0x100. At runtime the bootwrapper program copies
428 # the data at __system_reset_kernel back to addr 0x100.
429
430 system_reset_overlay=0x`${CROSS}nm "$ofile" \
431 | grep ' __system_reset_overlay$' \
432 | cut -d' ' -f1`
433 system_reset_overlay=`printf "%d" $system_reset_overlay`
434 system_reset_kernel=0x`${CROSS}nm "$ofile" \
435 | grep ' __system_reset_kernel$' \
436 | cut -d' ' -f1`
437 system_reset_kernel=`printf "%d" $system_reset_kernel`
438 overlay_dest="256"
439 overlay_size="512"
440
441 ${CROSS}objcopy -O binary "$ofile" "$ofile.bin"
442
443 dd if="$ofile.bin" of="$ofile.bin" conv=notrunc \
444 skip=$overlay_dest seek=$system_reset_kernel \
445 count=$overlay_size bs=1
446
447 dd if="$ofile.bin" of="$ofile.bin" conv=notrunc \
448 skip=$system_reset_overlay seek=$overlay_dest \
449 count=$overlay_size bs=1
450
451 odir="$(dirname "$ofile.bin")"
452 rm -f "$odir/otheros.bld"
453 gzip -n --force -9 --stdout "$ofile.bin" > "$odir/otheros.bld"
454 ;;
455esac